;
;   Random BMP Put Mini Sample by Pavlushin Evgeni for ASCL
;   www.waptap@mail.ru
;

;******************************************************************************
    use32
    org    0x0
    db     'MENUET01'              ; 8 byte id
    dd     0x01                    ; header version
    dd     START                   ; start of code
    dd     IM_END                  ; size of image
    dd     0x300000                ; memory for app
    dd     0x300000                ; esp
    dd     temp_area , 0x0         ; I_Param , I_Icon

;******************************************************************************


include 'ascl.inc'
include 'ascgl.inc'

START:                          ; start of execution
    call draw_window
still:
    scevent red,key,button
 
    mov dword [counter],10
put_loop:
    setimg dword [xt],dword [yt],image

    random 640-32 ,dword [xt]
    random 480-32 ,dword [yt]

    random 65536 , eax  ;regeneration for more combinations

    add dword [xt],5
    add dword [yt],25

    dec dword [counter]
    jnz put_loop

  ;  delay 1             ;don't generate delay for fast speed programm

    jmp  still

  red:
    call draw_window
    jmp still

  key:                          ; key
    int  0x40
    jmp  still

  button:                       ; button
    mov  eax,17                 ; get id
    int  0x40
    cmp  ah,1                   ; button id=1 ?
    jne  noclose
    mov  eax,-1                 ; close this program
    int  0x40
  noclose:
    jmp  still

load_image:
    loadfile '/rd/1/smile.bmp',I_END,temp_area
    bmptoimg I_END,image
    ret

draw_window:
    startwd
    window 0,0,640+8,480+24,window_Skinned
    label 12,8,'2D EXAMPLE: RANDOM PUT IMAGE',cl_White+font_Big
    call load_image
    endwd
    ret


; DATA AREA
xt dd 100
yt dd 100

counter dd 0
view dd 0
image:
rb 0x10000
IM_END:
temp_area:
rb 0x10000
I_END:
