#define _CRT_SECURE_NO_DEPRECATE
#define _USE_32BIT_TIME_T

#include <cstdio>
#include <cstring>
#include <ctime>
#include "coff.h"
#include "kdl.h"
#include "crc32.h"


#define f_enabled "[+]"
#define f_disabled "[-]"
dword len=0;
FILE *kdl_out;
unsigned long kdlCRC32 = 0xFFFFFFFF; 
unsigned long terminator = 0x0;
char **strings;

void showhelp()
{
	puts("  COFF2KDL");
	puts("Author: victor@kolibrios.org");
	puts("Usage: coff2kdl filename");
/*	puts("Usage: coff2kdl -c filename | [-b filename] input");
	puts("       -b filename : bind unresolved link");
	puts("       -c filename : file with config for linking");
    puts("       input       : object file");*/
}

char* getkdlname(char* objname)
{
	dword i = strlen(objname)-1;
	for(;i>0;i--)
		if(objname[i]=='.')break;
	char* kdlname = new char[i+1+3+1];
	kdlname[0]=0;
		strncpy(kdlname,objname,i+1);
	kdlname[i+1]='\0';
	return strcat(kdlname,"kdl");
}	

int getExportNameCount(SYMENT *symtab,long len){
	dword count=0;
	for(int i=0;i<len;i++){
		if(symtab[i].n_sclass == 2,symtab[i].n_scnum != 0) count++;
	}
	return count;
}

int getImportNameCount(SYMENT *symtab,long len){
	dword count=0;
	for(int i=0;i<len;i++){
		if(symtab[i].n_sclass == 2,symtab[i].n_scnum == 0) count++;
	}
	return count;
}
int getExportNameSize(SYMENT *symtab, char** strings, long len){
	dword size = 0;
	for(int i = 0; i < len; i++){
		if(symtab[i].n_sclass == 2,symtab[i].n_scnum != 0) size += strlen(strings[i]);
	}
	return size;
}
int getImportNameSize(SYMENT *symtab, char** strings, long len){
	dword size = 0;
	for(int i = 0; i < len; i++){
		if(symtab[i].n_sclass == 2,symtab[i].n_scnum == 0) size += strlen(strings[i]);
	}
	return size;
}
int getBssSize(SCNHDR *secth, unsigned short sect_count){
	int bss_size = 0;
	for(int i=0; i < sect_count; i++)
		if(secth[i].s_scnptr == 0)
			bss_size += secth[i].s_size;
	return bss_size;
}
int getImageSize(SCNHDR *secth, unsigned short sect_count){
	int image_size = 0;
	for(int i = 0; i < sect_count; i++)
		if(secth[i].s_scnptr != 0)
			image_size+=secth[i].s_size;
	return image_size;
}
int getFixupsCount(SCNHDR *secth, unsigned short sect_count){
	int rel_count = 0;
	for(int i = 0 ; i < sect_count; i++)
		rel_count += secth[i].s_nreloc;
	return rel_count;
}

void storeBlock(byte *buff, dword len){
	::len += len;
	int i=0;
	fwrite(buff, 1, len, kdl_out);
	kdlCRC32 = doCRC32(buff, len, kdlCRC32);
	while(len--) printf("%x",buff[i++]);
	printf("\n");
}
void storeDword(dword buff){
	storeBlock((byte*)&buff, sizeof(buff));
}
int main(int argc, char* argv[])
{
	int i;
    COFF_FILHDR objh;
    if(argc==1){
		showhelp();
		return 1;
	}
    FILE *obj = fopen(argv[1],"rb");
	if(obj==NULL){
		printf("file %s not found\n",argv[1]);
		return 1;
	}
	if(fread(&objh,COFF_FILHSZ,1,obj)==0){
		printf("file %s is wrong\n",argv[1]);
		return 1;
	}
	printf("COFF file %s\n",argv[1]);
	printf(" TimeDate stamp: %s",ctime(&objh.f_timdat));//      ctime()?
	printf(" Number of sections: %u bytes\n",objh.f_nscns);
	printf(" Size of optional header: %u bytes\n",objh.f_opthdr);
	if(objh.f_magic!=COFF_I386MAGIC)puts("! f_magic field is not equal to 0x14c");
    printf("Defined FLAGs: 0x%4.4x\n",objh.f_flags);
	printf(" %s F_RELFLG\n",(objh.f_flags&COFF_F_RELFLG)?f_enabled:f_disabled);
	printf(" %s F_EXEC\n",(objh.f_flags&COFF_F_EXEC)?f_enabled:f_disabled);
	printf(" %s F_LNNO\n",(objh.f_flags&COFF_F_LNNO)?f_enabled:f_disabled);
	printf(" %s F_LSYMS\n",(objh.f_flags&COFF_F_LSYMS)?f_enabled:f_disabled);
	printf(" %s F_LADDRS\n",(objh.f_flags&COFF_F_LADDRS)?f_enabled:f_disabled);
	printf(" %s F_16BIT\n",(objh.f_flags&COFF_F_16BIT)?f_enabled:f_disabled);
	printf(" %s F_REVLO\n",(objh.f_flags&COFF_F_REVLO)?f_enabled:f_disabled);
	printf(" %s F_AR32W\n",(objh.f_flags&COFF_F_AR32W)?f_enabled:f_disabled);
	printf(" %s F_DEBUG\n",(objh.f_flags&COFF_F_DEBUG)?f_enabled:f_disabled);
	puts("\nSections");

	SCNHDR *secth = new SCNHDR[objh.f_nscns];
	byte **sections = new unsigned char*[objh.f_nscns];
	fseek(obj,(int)objh.f_opthdr,SEEK_CUR);
	if(fread(secth,SCNHSZ,objh.f_nscns,obj)!=objh.f_nscns){
		puts("Error: sections is not readed");
		return 1;
	}

	for(i=0;i<objh.f_nscns;i++){
		if(secth[i].s_scnptr == 0) sections[i] = NULL;
		else{
			sections[i] = new unsigned char[secth[i].s_size];
			fread(sections[i],secth[i].s_size,1,obj);
		}
		printf("Name: %s\n",secth[i].s_name);
		printf("Size: 0x%x\n",(int)secth[i].s_size);
		printf("s_scnptr: 0x%x\n",(int)secth[i].s_scnptr);
		printf("s_relptr: 0x%x\n",(int)secth[i].s_relptr);
		printf("s_nreloc: 0x%x\n",(int)secth[i].s_nreloc);
		printf("s_paddr: 0x%x\n",(int)secth[i].s_paddr);
		printf("s_vaddr: 0x%x\n",(int)secth[i].s_vaddr);
        printf("Defined FLAGs: 0x%4.4x\n",(int)secth[i].s_flags);
		printf(" %s STYP_REG\n",(secth[i].s_flags&COFF_STYP_REG)?f_enabled:f_disabled);
		printf(" %s STYP_DSECT\n",(secth[i].s_flags&COFF_STYP_DSECT)?f_enabled:f_disabled);
		printf(" %s STYP_NOLOAD\n",(secth[i].s_flags&COFF_STYP_NOLOAD)?f_enabled:f_disabled);
		printf(" %s STYP_GROUP\n",(secth[i].s_flags&COFF_STYP_GROUP)?f_enabled:f_disabled);
		printf(" %s STYP_PAD\n",(secth[i].s_flags&COFF_STYP_PAD)?f_enabled:f_disabled);
		printf(" %s STYP_COPY\n",(secth[i].s_flags&COFF_STYP_COPY)?f_enabled:f_disabled);
		printf(" %s STYP_TEXT\n",(secth[i].s_flags&COFF_STYP_TEXT)?f_enabled:f_disabled);
		printf(" %s STYP_DATA\n",(secth[i].s_flags&COFF_STYP_DATA)?f_enabled:f_disabled);
		printf(" %s STYP_BSS\n",(secth[i].s_flags&COFF_STYP_BSS)?f_enabled:f_disabled);
		printf(" %s STYP_INFO\n",(secth[i].s_flags&COFF_STYP_INFO)?f_enabled:f_disabled);
		printf(" %s STYP_OVER\n",(secth[i].s_flags&COFF_STYP_OVER)?f_enabled:f_disabled);
		printf(" %s STYP_LIB\n",(secth[i].s_flags&COFF_STYP_LIB)?f_enabled:f_disabled);
	}
	RELOC **relocs = new RELOC*[objh.f_nscns];		
	for(i=0;i<objh.f_nscns;i++){
		printf("\nSection: %i count of reloc: %i\n",i,secth[i].s_nreloc);
		if(secth[i].s_nreloc!=0){
			relocs[i] = new RELOC[secth[i].s_nreloc];
			fread(relocs[i],RELSZ,secth[i].s_nreloc,obj);
			for(int j=0;j<secth[i].s_nreloc;j++){
				printf("%4u) va: %p | type: %2x | num: %3i\n",j+1,(void*)relocs[i][j].r_vaddr,relocs[i][j].r_type,relocs[i][j].r_symndx);
			}
		}
		else relocs[i]=NULL;
	}
	SYMENT *symtab = new SYMENT[objh.f_nsyms];
	fread(symtab,SYMESZ,objh.f_nsyms,obj);
	dword strings_sect_size;
	fread(&strings_sect_size,sizeof(strings_sect_size),1,obj);
	char *strings_sect = new char[strings_sect_size];
	fseek(obj,-4,SEEK_CUR);
	fread(strings_sect,strings_sect_size,1,obj);
	fclose(obj);

	strings = new char*[objh.f_nsyms];
	puts("SymTab:");
	for(i=0;i<objh.f_nsyms;i++){
		if(symtab[i].n_zeroes!=0){
			if(symtab[i].n_name[7]){
				strings[i] = strncpy(new char[8 + 1], symtab[i].n_name, 8);
				strings[i][8] = 0;
			}else strings[i] = symtab[i].n_name;
		}else strings[i] = strings_sect + symtab[i].n_offset;
		printf("%3.2i: class: %2i | sect: %2i | val:%5i | name: \"%s\"\n",i+1,symtab[i].n_sclass,symtab[i].n_scnum,symtab[i].n_value,strings[i]);
	}

	char* kdlname = getkdlname(argv[1]);
	puts(kdlname);
	InitCRC32();
	kdl_out = fopen(kdlname,"wb");
	KDL_FILHDR kdl_head;
//  (crc   )
	kdl_head.ver = (dword)KDL_VER;
	kdl_head.crc = 0;
	kdl_head.exports = KDL_FILHSZ;
	kdl_head.export_names = kdl_head.exports + 8 * getExportNameCount(symtab, objh.f_nsyms);
	kdl_head.imports = kdl_head.export_names + getExportNameSize(symtab, strings, objh.f_nsyms);
	kdl_head.image = kdl_head.imports + 4 * getImportNameCount(symtab, objh.f_nsyms);
	kdl_head.bss_size = kdl_head.image + getBssSize(secth, objh.f_nscns);
	kdl_head.fixups = kdl_head.image + getImageSize(secth, objh.f_nscns);
	kdl_head.import_names = kdl_head.fixups + RELSZ * getFixupsCount(secth, objh.f_nscns);
	storeBlock((byte*)&kdl_head, KDL_FILHSZ);
// 
	for(i = 0 ; i < objh.f_nsyms; i++){
		int offset=0;
		if(symtab[i].n_sclass == 2,symtab[i].n_scnum != 0){
			storeDword(symtab[i].n_value + secth[symtab[i].n_scnum].s_vaddr);
			storeDword(kdl_head.export_names + offset);
			offset += strlen(strings[i]);
		}
	}
	storeDword(terminator);
//  
	for(i = 0 ; i < objh.f_nsyms; i++)
		if(symtab[i].n_sclass == 2 && symtab[i].n_scnum != 0)
			storeBlock((byte*)strings[i], strlen(strings[i]));
	storeDword(terminator);
//  (  :/) -   ,  0
/*	for(i = 0 ; i < objh.f_nsyms; i++){
		int offset=0;
		if(symtab[i].n_sclass == 2,symtab[i].n_scnum != 0){
			storeDword(kdl_head.import_names + offset);
			offset += strlen(strings[i]);
		}
	}*/
	storeDword(terminator);
// 
	for(i = 0 ; i < objh.f_nscns; i++)
		if(secth[i].s_scnptr != 0)
			storeBlock(sections[i], secth[i].s_size);
//
	for(i = 0 ; i < objh.f_nscns; i++)
		if(secth[i].s_nreloc != 0)
			storeBlock((byte*)relocs[i], RELSZ * secth[i].s_nreloc + secth[i].s_vaddr);
//   -  
/*	for(i = 0 ; i < objh.f_nsyms; i++)
		if(symtab[i].n_sclass == 2 && symtab[i].n_scnum == 0)
			storeBlock(strings[i], strlen(strings[i]));
*/
	fseek(kdl_out, 4 /*crc*/, SEEK_SET);
	kdlCRC32 ^= 0xFFFFFFFF;
//	fwrite((dword*)&kdlCRC32, sizeof(dword), 1, kdl_out);
	printf("crc: %p\nlen: %d\n",(void*)kdlCRC32, ::len);
	fclose(kdl_out);
	return 0;
}
