;   
;   
;======================================
uglobal
;       
 DirEntry: ;  -   **** 
    .attr	dd ?
    ._reserved	dd ?	 ; ()
    .timeCreate dd ?	 ;  
    .dateCreate dd ?	 ;  
    .timeAccess dd ?	 ;   (  )
    .dateAccess dd ?	 ;  
    .timeModif	dd ?	 ;  
    .dateModif	dd ?	 ;  
    .size	dq ?	 ;    ( 16777216 )
endg
;====[ Codes ]====
READ_FILE  =  0
READ_DIR   =  1
READ_INFO  =  5
SEEK_BEGIN =  0
SEEK_CUR   =  1
SEEK_BACK  =  2
SEEK_END   =  3
DONE   =  0
EOF    =  6
INV_PARAM = 33

;====================
fopen:;//////////////
;====================
;in:
;  eax - file name
;out:
;  eax - code of result
;  ebx - pointer to fileInfo
;desc:
;     
       mov  ebx, eax
       mov  eax, sizeof.fileinfo
       call _mem_alloc
       push eax
       mov  [eax + fileinfo.name], ebx
       mov  ebx, eax
       mov  [ebx + fileinfo.data], DirEntry
       mov  [ebx + fileinfo.func], READ_INFO
       mcall 70
       pop  ebx
       push [DirEntry.size]
       pop  [ebx + fileinfo.fsize]
       ret

;====================
fread:;//////////////
;====================
;in:
;  eax - dest to read
;  ebx - file name
;  ecx - number of byte
;out:
;  -
;desc:
;
	mov   [ebx+fileinfo.data], ecx
	mov   [ebx+fileinfo.size], eax
	mov   [ebx+fileinfo.func], READ_FILE
	mcall 70
	ret


;====================
fsize:;//////////////
;====================
;in:
;  ebx - file
;out:
;  eax - size of file
;desc:
;
	mov  eax, [ebx+fileinfo.fsize]
	ret

;====================
fseek:;//////////////
;====================
;in:
;  eax -  
;  ebx - file name
;  ecx - number of byte
;out:
;  eax - 0 = , 6=   ,33= ,
;desc:
;
	test  eax, eax
	js .seek_begin
	dec   eax
	jz .seek_cur
	dec   eax
	jz .seek_back
	dec   eax
	jz .seek_end
	mov eax, INV_PARAM
    .seek_begin
	mov   eax, [ebx+fileinfo.fsize]
	cmp   eax, ecx
	jb    .seek_error
	mov   [ebx+fileinfo.offs], ecx
	mov   eax, DONE
	ret
    .seek_cur
	mov   eax, [ebx+fileinfo.fsize]
	add   eax, [ebx+fileinfo.offs]
	cmp   eax, ecx
	jb    .seek_error
	mov   [ebx+fileinfo.offs], ecx
	mov   eax, DONE
	ret
    .seek_back
    .seek_end
    .seek_error
	mov   eax, EOF
	ret

;====================
fclose:;/////////////
;====================
;in:
;  ebx - file
;out:
;  -
;desc:
;
	push eax
	mov  eax, ebx
	call _mem_free
	pop  eax
	ret

;====================
filename:;///////////
;====================
;in:
;  eax - path of file (relative, absolute..)
;out:
;  eax - pointer to name of file
;desc:
;         
	push esi
	push ebx
	mov  ebx, eax
	mov  esi, eax
   @@:;  
	lodsb
	cmp al,0
	je .found
	cmp al,'/'
	jne @b
	mov ebx,esi
	jmp @b
   .found:
	mov eax, ebx
	pop ebx
	pop esi
	ret
;====================
fileext:;///////////
;====================
;in:
;  eax - path of file (relative, absolute..)
;out:
;  eax - pointer to name of file
;desc:
;         ,   ,   
	push esi
	push ebx
	call filename
	mov  ebx, eax
	mov  esi, eax
   @@:;  
	lodsb
	cmp al,0
	je .found
	cmp al,'.'
	jne @b
	mov ebx,esi
	jmp @b
   .found:
	mov eax, ebx
	pop ebx
	pop esi
	ret
;====================
getfullpath:;////////
;====================
;in:
;  eax - path of file (relative, absolute..)
;out:
;  eax - pointer to alloced full path
;desc:
;    ,     

;====================
getpath:;////////////
;====================
;in:
;  eax - path of file (relative, absolute..)
;out:
;  eax - pointer to alloced path
;desc:
;    ,     (  )



struc fileinfo
{
 .func	dd ?   ; 
 .offs	dd ?   ;  
	dd ?   ; dword  (  0)
 .size	dd ?   ; (    )
 .data	dd ?   ;  
 .zero	db ?   ;
 .name	dd ?   ;  asciiz    
 .fsize dd ?
}
struct fileinfo



