include 'fileio.inc'
include 'hkdl.inc'


;iglobal
; ;loaded KDL
;  __count_loaded dd 1
;  __addr         rb (4+4)*coutn
;endg

uglobal
  __count_loaded dd ?
  __addr rb (4+4)*coutn
endg


;if used mem.alloc
;  _mem_alloc = mem.alloc
;  _mem_free = mem.free
;else if used MEM_Alloc
;  _mem_alloc = MEM_Alloc
;  _mem_free = MEM_Free
;else
;  display 'MM required!',13,10
;  halt
;end i

;===================================================
loadLibrary: ;//////////////////////////////////////
;===================================================
; 㧨 kdl
;  ebx =   ன 㧨
;  esi = asciiz, 
; ret eax: 0 - ok
;          1 - not found
;     ebx: , ஬ 㦥
;===================================================
 DEBUGF 'CALL loadLibrary\n eax:%x\n esi:%s\n',eax,esi
	fileio.set data,ebx
	mov edi,esi
	push esi
 @@:;⤥塞  䠩
	lodsb
	cmp al,0
	je findname
	cmp al,'/'
	jne @b
	mov edx,esi
	jmp @b
; । 㦥
;edi- 䠩 訢
;esi-   㦥 䠩
 findname:
;DEBUGF 'File name: %s\n',edx
	mov eax,[__count_loaded]
 @@:
	test eax,eax
	jz loadsdl
	mov edi,edx
	dec eax
	lea ebx,[eax*8 + __addr]
	mov esi,[ebx]
	mov ecx,[esi]
	add esi,4
	repe cmpsb
	jne @b
	test ecx,ecx
	jnz @b
;᫨ 䠩 㦥 㦥   㦥
	pop esi;頥 ⥪
	lea esi,[eax*8 + __addr + 4]
	mov ebx,[esi]
;hit_count + 1 ᫨  ࠢ -1
	mov eax,[ebx + kdl_header.hit_count]
	inc eax
	test eax,eax
 jz @f
	mov [ebx + kdl_header.hit_count],eax
 @@:
	xor eax,eax ;ret eax = 0
 DEBUGF 'KDL found at %x\n',ebx
	ret
 loadsdl:		;㧪 䠩   ᫨  
	pop esi
	fileio.set func,0,offs,0,size,-1,name,
;DEBUGF 'name: %s\n',fileio.name
;DEBUGF 'func: %x',[fileio.func]
;DEBUGF ' data: %x',[fileio.data]
;DEBUGF ' size: %x',[fileio.size]
;DEBUGF ' offs: %x\n',[fileio.offs]
	fileio.execute
DEBUGF 'fileio ret: %x\n',eax
	sub eax,6	;室 ᫨ 䠩  稫  ⥭
	jnz .NOT_LOAD
	mov ebx,[fileio.data]
	mov eax,[ebx + kdl_header.base_addr]
	cmp ebx,eax
    jz @f		;    
;reloc:
;⠢ ५ ᫨  㤠 㧨  㪠 
;    㪠
	sub eax,ebx
	sub [ebx + kdl_header.base_addr],eax
	sub [ebx + kdl_header.relocs],eax
	sub [ebx + kdl_header.name],eax
	sub [ebx + kdl_header.exports],eax
    @@:
	mov eax,[ebx]
	cmp eax,KDL_VER   ;verify KDL
	jnz .BAD_KDL
	mov [ebx + kdl_header.hit_count],1
;DEBUGF ' hit_count: %x\n ebx: %x\n',[ebx + kdl_header.hit_count],ebx
	mov eax,[__count_loaded]
	lea edi,[eax*8 + __addr]
	lea esi,[ebx + kdl_header.name]
	mov eax,[esi]
	mov [edi],eax
	mov ecx,[eax]
	add edi,4
	mov [edi],ebx
	lea esi,[eax + 4]   ;஢ઠ  ᮮ⢥⢨  䠩     ⠡ ப
	mov edi,edx	    ; edx ⠫  䠩
;DEBUGF 'compare names\n esi:%s\n edi:%s\n lenght:%x\n',esi,edi,ecx
	repe cmpsb
	jne .BAD_KDL
	test ecx,ecx
	jnz .BAD_KDL	    ;᫨   ᮢ  KDL ⠥ 訡筮
	inc [__count_loaded]
	
	mov ecx,[ebx + kdl_header.exports]
	sub ecx,LOAD_LIBRARY
	mov eax,loadLibrary
	mov [ecx],eax
	sub ecx,GET_PROC_ADDR
	mov eax,getprocaddr
	mov [ecx],eax
	sub ecx,FREE_LIBRARY
	mov eax,freelibrary
	mov [ecx],eax

	xor eax,eax ; ᯥ譮
	ret 
.NOT_LOAD:
 DEBUGF 'RET E_NOT_LOAD\n'
	mov eax,E_NOT_LOAD
	ret
.BAD_KDL:
 DEBUGF 'RET E_BAD_KDL\n'
	mov eax,E_BAD_KDL
	ret


;===================================================
freelibrary:
;ebx = handle
;ebx = 0 , ok
;===================================================
 DEBUGF 'CALL freelibrary\n ebx:%x\n',ebx
push eax
	add ebx,kdl_header.hit_count
	mov eax,[ebx]
	inc eax
	test eax,eax
 jnz @f
	dec eax
	dec eax
 jz clear
	mov [ebx],eax
 @@:
	mov ebx,E_UNLOAD_FAILED
pop eax
ret
 clear:
push edx
	mov eax,[__count_loaded]
 @@:
	test eax,eax
	jz .NOT_FOUND
	dec eax
	lea edx,[eax*8 + __addr + 4]
	cmp edx,ebx
	jne @b
	dec [__count_loaded]
	mov eax,[__count_loaded]
	lea ebx,[eax*8 + __addr + 4]
	mov eax,[ebx]
	mov [edx],eax
	sub ebx,4
	sub edx,4
	mov eax,[ebx]
	mov [edx],eax
	xor ebx,ebx
DEBUGF 'freelibrary() succeeded\n'
pop edx
pop eax
ret
 .NOT_FOUND:
	mov ebx,E_NOT_FOUND
DEBUGF 'freelibrary() failed\n E_NOT_FOUND\n'
pop edx
pop eax
ret
	
;==================================================
;  㭪樨
;in: esi=  㭪樨
;    ebx= 㦥 kdl
;out: eax=0,  ,    訡
;     ebx= 㭪樨
getprocaddr:
;===================================================
;  ஢ ᨣ MDL0   
; DEBUGF 'CALL getprocaddr\n ebx:%x\n esi:%s\n',ebx,esi
	mov eax,esi
	mov edx,[ebx + kdl_header.proc_count]
; DEBUGF ' fcount :%x\n',edx
     @@:
	test edx,edx
	jz .NOT_FOUND
	dec edx
	lea edi,[ebx + edx*8 + kdl_header.proc_table]
	mov edi,[edi]
	mov ecx,[edi]
	add edi,4
; DEBUGF ' fname :%s edi: %x\n',edi,edi
	mov esi,eax
	repe cmpsb
	jne @b
	test ecx,ecx
	jnz @b
	lea edi,[ebx + edx*8 + kdl_header.proc_table + 4]
	mov ebx,[edi]
	xor eax,eax
; DEBUGF 'ret ebx %x\n',ebx
    ret

.NOT_FOUND:
	mov eax,E_NOT_FOUND
DEBUGF 'ret E_NOT_FOUND\n',eax
    ret

