;   
;======================================
; esi - source string
; edi - dest string
; ecx - string length
; eax - code of result
;====================
strlen:;//////////////
;====================
;in:
;  esi - string
;out:
;  ecx - length
;desc:
;  -
     push  eax
     xor   ecx, ecx
@@:  lodsb
     inc   ebx
     test  al, al
     jnz   @b
     pop   eax
     ret


;====================
strcpy:;//////////////
;====================
;in:
;  esi - source string
;  edi - dest string
;out:
;  -
;desc:
;  -
@@:  lodsb
     stosb
     test al,al
     jnz @b
     ret

;====================
strncpy:;//////////////
;====================
;in:
;  esi - source string
;  edi - dest string
;  ecx - max length
;out:
;  -
;desc:
;  -
@@:  lodsb
     stosb
     dec  ecx
     test ecx, ecx
     retz
     test al,al
     jnz @b
     ret

;====================
strcmp:;/////////////
;====================
;in:
;  esi - first string
;  edi - second string
;out:
;  eax - result
;       -1 - first is below
;        0 - strings is equal
;        1 - first is above
;desc:
;  -
@@:  lodsb
     cmp  al, [edi]
     jnz  .ready
     test al, al
     jz   .ready
     inc  edi
     jmp  @b
 .ready:
     ja   .above
     jb   .below
     xor  eax, eax
     ret
 .above:
     mov  eax, 1
     ret
 .below:
     mov  eax, -1
     ret

;====================
strncmp:;////////////
;====================
;in:
;  esi - first string
;  edi - second string
;  ecx - max length
;out:
;  eax - result (as strcmp)
;desc:
;  -
@@:  lodsb
     cmp  al, [edi]
     jnz  .ready
     test al, al
     jz   strcmp.ready
     dec  ecx
     test ecx, ecx
     jz   strcmp.ready
     inc  edi
     jmp  @b

;====================
strcat:;/////////////
;====================
;in:
;  esi - first string
;  edi - second string
;  ecx - max length
;out:
;  -
;desc:
;  -
     push eax
@@:  lodsb
     cmp  al, al
     jnz  @b
     xchg esi, edi
@@:  lodsb
     stosb
     test al, al
     jnz  @b
     pop  eax
     ret

;====================
strncat:;////////////
;====================
;in:
;  esi - first string
;  edi - second string
;  ecx - max length
;out:
;  -
;desc:
;  -
     pop eax
@@:  lodsb
     cmp  al, al
     jnz  @b
     xchg esi, edi
@@:  lodsb
     stosb
     dec  ecx
     test ecx, ecx
     jz   @f
     test al, al
     jnz  @b
@@:  pop  eax
     ret

;====================
strstr:;/////////////
;====================
;in:
;  esi - first string
;  edi - second string
;out:
;  eax - position of first entry
;desc:
; edx     
; ebp      
; ebp+4      
; ebp+8      
      push edx
      push ecx
      push esi
      push edi
      mov  esi, edi
      call strlen
      push ecx
      push ebp
      mov  ebp, esp
      add  ebp, 4
      xor  edx, edx
@@:   call strncmp
      test eax, eax
      jz   .done
      inc  edx
      mov  edi, [ebp+4]
      mov  esi, [ebp]
      mov  ecx, [ebp+8]
      add  esi, edx
      mov  eax, [esi]
      test eax, eax
      jz   .not_found
      jmp  @b
  .done:
      pop  ebp
      pop  eax
      pop  eax
      pop  ecx
      mov  eax, edx
      pop  edx
      ret
  .not_found:
      pop  ebp
      pop  eax
      pop  eax
      pop  ecx
      pop  edx
      mov  eax, -1
      ret
;==============
;enter 12,0
;mov [ebp],esi
;mov [ebp+4],edi
;mov esi, edi
;call strlen
;mov [ebp+8],ecx
;==============
