	format PE native
entry start

start:
;	int	3
	push	ebx
	push	esi
	push	edi
; find ntoskrnl base
	mov	esi, [esp+12]	; return address is in ntoskrnl
	mov	eax, [MmSystemRangeStart]
	mov	ebx, [eax]
	cmp	ebx, esi
	ja	err_base
	and	esi, not 0FFFh
@@:
	push	esi
	call	[MmIsAddressValid]
	cmp	al, 0
	jz	err_base
	cmp	dword [esi], 00905A4Dh
	jz	base_found
	sub	esi, 1000h
	cmp	esi, ebx
	jae	@b
err_base:
	mov	eax, 0C000000Eh		; STATUS_NO_SUCH_DEVICE
xret:
	pop	edi
	pop	esi
	pop	ebx
	ret	8
base_found:
; base is now in esi
	mov	ebx, esi
	add	ebx, [esi+3Ch]
; ebx contains PE header address
; scan sections table
	movzx	eax, word [ebx+14h]
	mov	eax, [eax+ebx+18h+0Ch]	; RVA of first section
	add	eax, esi
	mov	edx, [HalReturnToFirmware]
	mov	ecx, 1000h/4
@@:
	cmp	[eax], edx
	jz	@f
	add	eax, 4
	loop	@b
	mov	eax, 0C000000Eh		; STATUS_NO_SUCH_DEVICE
	jmp	xret
@@:
	mov	[HalReturnToFirmwareOfs], eax
;	mov	dword [eax], MyReboot	; this will be done later
; scan for ACPI
;	push	eax
;	mov	eax, esp
;	push	mfaattr
;	push	20019h
;	push	eax
;	call	[ZwOpenKey]
;	pop	edi
;	test	eax, eax
;	js	acpi_scan_end
;	xor	ebx, ebx
;	mov	[mfaattr+8], bufstr
;	mov	[mfaattr+4], edi
;acpi_scan_loop1:
;	push	bufstr
;	push	10
;	push	ebx
;	call	[RtlIntegerToUnicodeString]
;	push	eax
;	mov	eax, esp
;	push	mfaattr
;	push	20019h
;	push	eax
;	call	[ZwOpenKey]
;	pop	esi
;	test	eax, eax
;	js	acpi_scan_close
;	mov	ecx, idstr
;	call	read_reg_value
;	test	eax, eax
;	js	acpi_scan_continue
;	cmp	dword [edx+8], 9
;	jb	acpi_scan_l1
;	lea	esi, [edx+0Ch]
;	mov	edi, aAcpiBios
;	mov	ecx, 9
;	repz	cmpsw
;	jnz	acpi_scan_l1
;	cmp	dword [edx+8], 9
;	jz	acpi_found
;	cmp	word [edi], 0
;	jz	acpi_found
;acpi_scan_l1:
;	push	edx
;	call	[ExFreePool]
;acpi_scan_continue:
;	push	esi
;	call	[ZwClose]
;	inc	ebx
;	jmp	acpi_scan_loop1
;acpi_found:
;	push	edx
;	call	[ExFreePool]
;	mov	ecx, cfgdatastr
;	call	read_reg_value
;	test	eax, eax
;	js	acpi_scan_continue
;	push	edx
;	push	esi
;	call	[ZwClose]
;	push	edi
;	call	[ZwClose]
;	pop	esi
;	jmp	acpi_scan_end
;acpi_scan_close:
;	push	edi
;	call	[ZwClose]
	push	eax
	mov	eax, esp
	push	objattr
	push	20019h
	push	eax
	call	[ZwOpenKey]
	pop	esi
	test	eax, eax
	js	acpi_scan_end
acpi_child_loop:
	call	get_key_child
	test	eax, eax
	js	acpi_scan_close
	push	edx
	lea	eax, [edx+10h]
	push	eax
	push	word [edx+0Ch]
	push	word [edx+0Ch]
	mov	[objattr+8], esp
	mov	[objattr+4], esi
	push	eax
	mov	eax, esp
	push	objattr
	push	20019h
	push	eax
	call	[ZwOpenKey]
	pop	edi
	pop	ecx
	pop	ecx
	pop	edx
	push	eax
	push	edx
	call	[ExFreePool]
	push	esi
	call	[ZwClose]
	mov	esi, edi
	pop	eax
	test	eax, eax
	js	acpi_scan_end
	dec	[count]
	jnz	acpi_child_loop
	mov	ecx, valuename
	call	read_reg_value
	test	eax, eax
	js	acpi_scan_close
	add	edx, 0xC
	mov	[acpi_fadt], edx
	cmp	dword [edx], 'FACP'
	jz	acpi_scan_close
	sub	edx, 0xC
	push	edx
	push	esi
	call	[ZwClose]
	call	[ExFreePool]
	mov	eax, 0xC0140019		; STATUS_ACPI_INVALID_TABLE
	jmp	xret
acpi_scan_close:
	push	esi
	call	[ZwClose]
acpi_scan_end:
; map physical addresses
	xor	ebx, ebx
	push	ebx
	push	4
	push	ebx
	push	467h
	call	[MmMapIoSpace]
	test	eax, eax
	jnz	@f
nores:
	mov	eax, 0C000009Ah		; STATUS_INSUFFICIENT_RESOURCES
	jmp	xret
@@:
	mov	[_467], eax
	push	ebx
	push	2000h
	push	ebx
	push	0D000h
	call	[MmMapIoSpace]
	test	eax, eax
	jz	nores
	mov	[_D000], eax
; create virtual device object
	push	eax
	push	esp
	push	ebx
	push	ebx
	push	22h	; FILE_DEVICE_UNKNOWN
	push	devname
	push	ebx
	push	dword [esp+2Ch]
	call	[IoCreateDevice]
	pop	esi
	test	eax, eax
	js	xret
	push	devname
	push	symlinkname
	call	[IoCreateSymbolicLink]
	test	eax, eax
	jns	@f
	push	eax
	push	esi
	call	[IoDeleteDevice]
	pop	eax
	jmp	xret
@@:
	mov	eax, [esp+10h]
	mov	dword [eax+38h], DispatchCreateClose
	mov	dword [eax+40h], DispatchCreateClose
	mov	dword [eax+70h], DispatchControl
	xor	eax, eax
	jmp	xret

read_reg_value:
; in: ecx=value name, esi=handle
; out: eax=status, edx=value data
	push	ecx
	push	eax
	push	esp
	push	0
	push	0
	push	2
	push	ecx
	push	esi
	call	[ZwQueryValueKey]
	pop	edx	; ReturnLength
	cmp	eax, 80000005h	; STATUS_BUFFER_OVERFLOW
	jz	@f
	cmp	eax, 0xC0000023	; STATUS_BUFFER_TOO_SMALL
	jz	@f
	pop	ecx
	ret
@@:
	push	edx
	push	'KLBR'
	push	edx
	push	0
	call	[ExAllocatePoolWithTag]
	pop	edx
	pop	ecx
	test	eax, eax
	jz	.nomem
	push	eax
	push	eax
	push	esp
	push	edx
	push	eax
	push	2
	push	ecx
	push	esi
	call	[ZwQueryValueKey]
	pop	ecx
	pop	edx
	test	eax, eax
	jns	@f
	push	eax
	push	edx
	call	[ExFreePool]
	pop	eax
@@:
	ret
.nomem:
	mov	eax, 0xC000009A		; STATUS_INSUFFICIENT_RESOURCES
	ret

get_key_child:
	push	eax
	push	esp
	push	0
	push	0
	push	0
	push	0
	push	esi
	call	[ZwEnumerateKey]
	pop	edx
	cmp	eax, 80000005h	; STATUS_BUFFER_OVERFLOW
	jz	@f
	cmp	eax, 0xC0000023	; STATUS_BUFFER_TOO_SMALL
	jz	@f
	ret
@@:
	push	edx
	push	'KLBR'
	push	edx
	push	0
	call	[ExAllocatePoolWithTag]
	pop	edx
	test	eax, eax
	jz	read_reg_value.nomem
	push	eax
	push	eax
	push	esp
	push	edx
	push	eax
	push	0
	push	0
	push	esi
	call	[ZwEnumerateKey]
	pop	edx
	pop	edx
	test	eax, eax
	jns	@f
	push	eax
	push	edx
	call	[ExFreePool]
	pop	eax
@@:
	ret

DispatchCreateClose:
	mov	ecx, [esp+8]
	xor	edx, edx
	mov	[ecx+18h], edx
	mov	[ecx+1Ch], edx
	call	[IofCompleteRequest]
	xor	eax, eax
	ret	8

DispatchControl:
;	int	3
	mov	ecx, [esp+8]
	mov	eax, [ecx+60h]
	cmp	dword [eax+0Ch], 0x22203C
	jnz	.invreq
	mov	edx, [eax+8]
	cmp	edx, 300
	ja	.invreq
	test	edx, edx
	jz	.invreq
	mov	eax, [ecx+0Ch]
	mov	al, [eax]
	or	al, 20h
	sub	al, 60h
	jz	.invreq
	cmp	al, 'z'-60h
	ja	.invreq
	push	edx
	push	ecx
; map drive letter to physical drive and partition
	add	al, 40h
	mov	byte [driveletter], al
	push	eax
	mov	eax, esp
	push	eax
	push	esp	; DeviceObject
	push	eax	; FileObject
	push	80h	; DesiredAccess
	push	phdname
	call	[IoGetDeviceObjectPointer]
	test	eax, eax
	jns	.ok1
.err0:
	pop	ecx
	pop	ecx
.err1:
	pop	ecx
	pop	edx
.return:
	mov	edx, [HalReturnToFirmware]
	test	eax, eax
	js	@f
	mov	edx, MyReboot
@@:
	push	eax
	mov	[ecx+18h], eax
	mov	eax, [HalReturnToFirmwareOfs]
	mov	[eax], edx
	xor	edx, edx
	mov	[ecx+1Ch], edx
	call	[IofCompleteRequest]
	pop	eax
	ret	8
.invreq:
	mov	eax, 0xC0000010	; STATUS_INVALID_DEVICE_REQUEST
	jmp	.return
.ok1:
; physical drive
	mov	eax, 2D1080h	; IOCTL_STORAGE_GET_DEVICE_NUMBER
	mov	edx, storage_device_number
	mov	ecx, 12
	call	DeviceIoControl
	test	eax, eax
	jns	@f
.err2:
	pop	ecx
	pop	ecx
	push	eax
	push	ecx
	call	[ObDereferenceObject]
	pop	eax
	jmp	.err1
@@:
	cmp	dword [storage_device_number], 7
	mov	eax, 0xC0000012	; STATUS_WRONG_VOLUME
	jnz	.err2
; partition offset
	mov	eax, 74004h	; IOCTL_DISK_GET_PARTITION_INFO
	mov	edx, partition_info
	mov	ecx, 32
	call	DeviceIoControl
	test	eax, eax
	js	.err2
	pop	ecx
	call	[ObDereferenceObject]
; now set up mtldr
	mov	edx, [esp+4]
	dec	edx
	push	'KLBR'
	push	edx
	push	0
	call	[ExAllocatePoolWithTag]
	mov	[imgname], eax
	or	eax, eax
	mov	eax, 0xC000009A
	jz	.err1
	mov	al, [storage_device_number+4]
	or	al, 80h
	mov	[mtldr+4], al
	mov	eax, dword [partition_info]
	mov	edx, dword [partition_info+4]
	shrd	eax, edx, 9
;	shr	edx, 9
	mov	dword [mtldr], eax
	pop	ecx
	pop	edx
	dec	edx
	push	esi
	push	edi
	mov	esi, [ecx+0Ch]
	inc	esi
	mov	edi, [imgname]
.1:
	lodsb
	cmp	al, 'A'
	jb	@f
	cmp	al, 'Z'
	ja	@f
	or	al, 20h
@@:
	stosb
	dec	edx
	jnz	.1
	dec	edi
	xor	eax, eax
	stosb		; force null-terminating
	pop	edi
	pop	esi
	jmp	.return

DeviceIoControl:
; in: [esp+4]=DeviceObject, eax=IoControlCode, edx=OutBuffer, ecx=OutBufLen
	push	esi
	sub	esp, 10h
	mov	esi, esp
	push	iosb		; IoStatusBlock
	push	esi		; Event
	push	0		; InternalDeviceIoControl
	push	ecx		; OutputBufferLength
	push	edx		; OutputBuffer
	push	0		; InputBufferLength
	push	0		; InputBuffer
	push	dword [esi+18h]	; DeviceObject
	push	eax		; IoControlCode
	push	0
	push	0
	push	esi
	call	[KeInitializeEvent]
	call	[IoBuildDeviceIoControlRequest]
	test	eax, eax
	jnz	@f
	mov	eax, 0xC000009A		; STATUS_INSUFFICIENT_RESOURCES
	jmp	.exit
@@:
	mov	ecx, [esi+18h]
	mov	edx, eax
	call	[IofCallDriver]
	cmp	eax, 103h
	jnz	.exit
	push	0
	push	0
	push	0
	push	0
	push	esi
	call	[KeWaitForSingleObject]
	mov	eax, [iosb]
.exit:
	add	esp, 10h
	pop	esi
	ret

MyReboot:
;	int	3
	cli
	mov	ecx, [acpi_fadt]
	jecxz	@f
; turn ACPI off
	mov	edx, [ecx+48]	; SMI_CMD
	test	edx, edx
	jz	@f
	mov	al, [ecx+53]
	out	dx, al
@@:
	mov	eax, [_467]
	mov	dword [eax], 0D000007h	; 0D00:0007
	mov	al, 0Fh
	out	70h, al
	jecxz	$+2
	jecxz	$+2
	mov	al, 5
	out	71h, al
	mov	edi, [_D000]
	mov	esi, mtldr
	mov	ecx, mtldr_size
	rep	movsb
; copy mtldr parameters
	mov	esi, [imgname]
	mov	edi, esi
	mov	al, 0
	xor	ecx, ecx
	dec	ecx
	repnz	scasb
	mov	edi, [_D000]
	not	ecx
	movzx	eax, word [edi+5]
	add	edi, eax
	rep	movsb
; load old IDT
	lidt	[oldidt]
; reboot
	mov	al, 0FEh
	out	64h, al
	hlt

oldidt:
	dw	3FFh
	dd	0
devname:
	dw	14*2
	dw	15*2
	dd	@f
@@	du	'\Device\ldklbr',0
symlinkname:
	dw	18*2
	dw	19*2
	dd	@f
@@	du	'\DosDevices\ldklbr',0

;mfaname:
;	dw	.a - 2
;	dw	.a
;	dd	@f
;@@	du	'\Registry\Machine\Hardware\Description\System\MultifunctionAdapter',0
;.a = $ - @b
;idstr:
;	dw	10*2
;	dw	11*2
;	dd	@f
;@@	du	'Identifier',0
;cfgdatastr:
;	dw	18*2
;	dw	19*2
;	dd	@f
;@@	du	'Configuration Data',0
;aAcpiBios du	'ACPI BIOS'
;mfaattr:
;	dd	.a - mfaattr
;	dd	0
;	dd	mfaname
;	dd	40h
;	dd	0
;	dd	0
;.a:
;bufstr:
;	dw	0
;	dw	20*2
;	dd	buf
objattr:
	dd	.a - objattr
	dd	0
	dd	obj1name
	dd	40h
	dd	0
	dd	0
.a:
obj1name:
	dw	.x1-2
	dw	.x1
	dd	@f
@@	du	'\Registry\Machine\Hardware\ACPI\FADT',0
.x1 = $ - @b
valuename:
	dw	8*2
	dw	9*2
	dd	@f
@@	du	'00000000',0
count	db	3

phdname:
	dw	14*2
	dw	15*2
	dd	@f
@@	du	'\DosDevices\'
driveletter du	'C'
	du	':',0

mtldr:
	file	'mtldr'
mtldr_size = $ - mtldr

include 'e:\zhenya\program\asm\fasmw164\include\win32a.inc'
data import
	library ntoskrnl,'ntoskrnl.exe',hal,'HAL.dll'
	import ntoskrnl, \
MmIsAddressValid,'MmIsAddressValid', \
MmSystemRangeStart,'MmSystemRangeStart', \
IoCreateDevice,'IoCreateDevice', \
IoCreateSymbolicLink,'IoCreateSymbolicLink', \
IoDeleteDevice,'IoDeleteDevice', \
MmMapIoSpace,'MmMapIoSpace', \
ZwOpenKey,'ZwOpenKey',\
ZwQueryValueKey,'ZwQueryValueKey',\
ZwClose,'ZwClose',\
ObDereferenceObject,'ObDereferenceObject',\
ZwEnumerateKey,'ZwEnumerateKey',\
ExAllocatePoolWithTag,'ExAllocatePoolWithTag',\
ExFreePool,'ExFreePool',\
IofCompleteRequest,'IofCompleteRequest',\
IoGetDeviceObjectPointer,'IoGetDeviceObjectPointer',\
IoBuildDeviceIoControlRequest,'IoBuildDeviceIoControlRequest',\
KeInitializeEvent,'KeInitializeEvent',\
KeWaitForSingleObject,'KeWaitForSingleObject',\
IofCallDriver,'IofCallDriver'
	import hal,HalReturnToFirmware,'HalReturnToFirmware'
end data

data fixups
end data

acpi_fadt dd	0
HalReturnToFirmwareOfs dd ?
_467	dd	?
_D000	dd	?

;buf	rw	20
iosb	rd	2

; second DWORD of storage_device_number is DeviceNumber
storage_device_number	rb	0xC
; first QWORD of partition_info is StartingOffset (in sectors)
partition_info		rb	0x20
imgname dd ?
