	format binary
	use32

macro show_addr title,addr
{
	local s,d
	s = addr
	display title,': 0x'
	repeat 4
		d = 48 + s shr ((4-%) shl 2) and 15
		if d>57
			d = d+65-57-1
		end if
		display d
	end repeat
	display 13,10
}

	dd	unpacker-_RangeDecoderBitDecode
	db	4
	dd	12345678h	; will be patched
	dd	-1
	dd	_LzmaLenDecode-_RangeDecoderBitDecode
	dd	_RangeDecoderBitDecode-_RangeDecoderBitDecode
RangeDecoderBitDecode	equ	dword [ebx]
LzmaLenDecode		equ	dword [ebx-4]
code_	equ	ebx-12
range	equ	ebx-8

rep1		equ	ebx+4
rep2		equ	ebx+8
rep3		equ	ebx+12
inptr		equ	ebx+16

pb	equ	2	; pos state bits
lp	equ	0	; literal pos state bits
lc	equ	3	; literal context bits
posStateMask	equ	((1 shl pb)-1)
literalPosMask	equ	((1 shl lp)-1)

kNumPosBitsMax	=	4
kNumPosStatesMax =	(1 shl kNumPosBitsMax)

kLenNumLowBits	=	3
kLenNumLowSymbols =	(1 shl kLenNumLowBits)
kLenNumMidBits	=	3
kLenNumMidSymbols =	(1 shl kLenNumMidBits)
kLenNumHighBits	=	8
kLenNumHighSymbols =	(1 shl kLenNumHighBits)

LenChoice	=	0
LenChoice2	=	1
LenLow		=	2
LenMid		=	(LenLow + (kNumPosStatesMax shl kLenNumLowBits))
LenHigh		=	(LenMid + (kNumPosStatesMax shl kLenNumMidBits))
kNumLenProbs	=	(LenHigh + kLenNumHighSymbols)

kNumStates	=	12
kNumLitStates	=	7
kStartPosModelIndex =	4
kEndPosModelIndex =	14
kNumFullDistances =	(1 shl (kEndPosModelIndex/2))
kNumPosSlotBits =	6
kNumLenToPosStates =	4
kNumAlignBits	=	4
kAlignTableSize	=	(1 shl kNumAlignBits)
kMatchMinLen	=	2

IsMatch		=	0
IsRep		=	0xC0	; (IsMatch + (kNumStates shl kNumPosBitsMax))
IsRepG0		=	0xCC	; (IsRep + kNumStates)
IsRepG1		=	0xD8	; (IsRepG0 + kNumStates)
IsRepG2		=	0xE4	; (IsRepG1 + kNumStates)
IsRep0Long	=	0xF0	; (IsRepG2 + kNumStates)
PosSlot		=	0x1B0	; (IsRep0Long + (kNumStates shl kNumPosBitsMax))
SpecPos		=	0x2B0	; (PosSlot + (kNumLenToPosStates shl kNumPosSlotBits))
Align_		=	0x322	; (SpecPos + kNumFullDistances - kEndPosModelIndex)
Lencoder	=	0x332	; (Align_ + kAlignTableSize)
RepLencoder	=	0x534	; (Lencoder + kNumLenProbs)
Literal		=	0x736	; (RepLencoder + kNumLenProbs)

LZMA_BASE_SIZE	=	1846	; must be ==Literal
LZMA_LIT_SIZE	=	768

kNumTopBits	=	24
kTopValue	=	(1 shl kNumTopBits)

kNumBitModelTotalBits =	11
kBitModelTotal	=	(1 shl kNumBitModelTotalBits)
kNumMoveBits	=	5

uninit_base	=	125F0000h

p	=	uninit_base
show_addr 'uninitialized size', \
	p + (LZMA_BASE_SIZE + (LZMA_LIT_SIZE shl (lc+lp)) + 0xFF)/0x100*0x400 - uninit_base

_RangeDecoderBitDecode:
; in: eax->prob
; out: CF=bit
	push	edx
	mov	edx, [range]
	shr	edx, kNumBitModelTotalBits
	imul	edx, [eax]
	cmp	[code_], edx
	jae	.ae
	mov	[range], edx
	mov	edx, kBitModelTotal
	sub	edx, [eax]
	shr	edx, kNumMoveBits
	add	[eax], edx
.n:
	pushfd
	call	update_decoder
	popfd
	pop	edx
	ret
.ae:
	sub	[range], edx
	sub	[code_], edx
	mov	edx, [eax]
	shr	edx, kNumMoveBits
	sub	[eax], edx
	stc
	jmp	.n

update_decoder:
	cmp	byte [range+3], 0	;cmp	dword [range], kTopValue
	jnz	@f			;jae	@f
	shl	dword [range], 8
	shl	dword [code_], 8
	push	eax
	mov	eax, [inptr]
	mov	al, [eax]
	inc	dword [inptr]
	mov	byte [code_], al
	pop	eax
@@:	ret

_LzmaLenDecode:
; in: eax->prob, edx=posState
; out: ecx=len

; LenChoice==0
;	add	eax, LenChoice*4
if kLenNumMidBits <> kLenNumLowBits
error in optimization
end if
	mov	cl, kLenNumMidBits
	call	RangeDecoderBitDecode
	jnc	.0
	add	eax, (LenChoice2-LenChoice)*4
	call	RangeDecoderBitDecode
	jc	@f
if (kLenNumMidBits <> 3) | (LenMid-LenChoice2 > 0x7F + kLenNumMidBits)
	shl	edx, cl
	add	edx, LenMid-LenChoice2
else
	lea	edx, [ecx + edx*8 - kLenNumMidBits + LenMid-LenChoice2]
end if
	push	kLenNumLowSymbols
	jmp	RangeDecoderBitTreeDecode.1
@@:
	mov	edx, LenHigh-LenChoice2
	mov	cl, kLenNumHighBits
	push	kLenNumLowSymbols + kLenNumMidSymbols
	jmp	RangeDecoderBitTreeDecode.1
.0:
	shl	edx, cl
if LenLow = 2
	inc	edx
	inc	edx
else
	add	edx, LenLow
end if
RangeDecoderBitTreeDecode:
; in: eax+edx*4->probs,ecx=numLevels
; out: ecx=length; destroys edx
	push	0
.1:
	push	edi
	lea	edi, [eax+edx*4]
	xor	edx, edx
	inc	edx
	mov	eax, edx
@@:
	push	eax
	lea	eax, [edi+edx*4]
	call	RangeDecoderBitDecode
	pop	eax
	adc	dl, dl
	add	al, al
	loop	@b
	sub	dl, al
	pop	edi
	pop	ecx
	add	ecx, edx
	ret

unpacker:
	xor	ebp, ebp
	xor	eax, eax
	dec	eax
	lea	edi, [rep1]
	stosd
	stosd
	stosd
	xchg	eax, esi
	stosd
;	mov	ecx, Literal + (LZMA_LIT_SIZE shl (lc+lp))
	mov	ch, (Literal + (LZMA_LIT_SIZE shl (lc+lp)) + 0xFF) shr 8
	mov	eax, kBitModelTotal/2
	mov	edi, p
	rep	stosd
	push	'4'
show_addr 'indelta',$-1-_RangeDecoderBitDecode
	pop	edi
.main_loop:
	cmp	edi, 'PARE'
show_addr 'pare',$-4-_RangeDecoderBitDecode
	jae	.main_loop_done
	mov	edx, edi
	and	edx, posStateMask
	push	eax	; al = previous byte
	mov	eax, ebp
	shl	eax, kNumPosBitsMax+2
	lea	eax, [p + IsMatch*4 + eax + edx*4]
	call	RangeDecoderBitDecode
	pop	eax
	jc	.1
	movzx	eax, al
if literalPosMask
	mov	ah, dl
	and	ah, literalPosMask
end if
if ((LZMA_LIT_SIZE*4) and ((1 shl (8-lc)) - 1)) <> 0
	shr	eax, 8-lc
	imul	eax, LZMA_LIT_SIZE*4
else
	and	al, not ((1 shl (8-lc)) - 1)
	imul	eax, (LZMA_LIT_SIZE*4) shr (8-lc)
end if
	add	eax, p+Literal*4
	mov	cl, 1
	cmp	ebp, kNumLitStates
	jb	.literal
	mov	dl, [edi + esi]
.lx0:
	add	dl, dl
	adc	ch, 1
	push	eax
	lea	eax, [eax+ecx*4]
	call	RangeDecoderBitDecode
	pop	eax
	adc	cl, cl
	jc	.lx1
	xor	ch, cl
	test	ch, 1
	mov	ch, 0
	jnz	.lx0
.literal:
@@:
	push	eax
	lea	eax, [eax+ecx*4]
	call	RangeDecoderBitDecode
	pop	eax
	adc	cl, cl
	jnc	@b
.lx1:
	mov	eax, ebp
	cmp	al, 4
	jb	@f
	cmp	al, 10
	mov	al, 3
	jb	@f
	mov	al, 6
@@:	sub	ebp, eax
	xchg	eax, ecx
.stosb_main_loop:
	stosb
	jmp	.main_loop
.1:
	lea	eax, [p + IsRep*4 + ebp*4]
	call	RangeDecoderBitDecode
	jnc	.10
	add	eax, (IsRepG0 - IsRep)*4	;lea	eax, [p + IsRepG0*4 + ebp*4]
	call	RangeDecoderBitDecode
	jc	.111
	mov	eax, ebp
	shl	eax, kNumPosBitsMax+2
	lea	eax, [p + IsRep0Long*4 + eax + edx*4]
	call	RangeDecoderBitDecode
	jc	.1101
	cmp	ebp, 7
	sbb	ebp, ebp
	lea	ebp, [ebp+ebp+11]
	mov	al, [edi + esi]
	jmp	.stosb_main_loop
.111:
	add	eax, (IsRepG1 - IsRepG0) * 4	;lea	eax, [p + IsRepG1*4 + ebp*4]
	call	RangeDecoderBitDecode
	xchg	esi, [rep1]
	jnc	@f
	add	eax, (IsRepG2 - IsRepG1) * 4	;lea	eax, [p + IsRepG2*4 + ebp*4]
	call	RangeDecoderBitDecode
	xchg	esi, [rep2]
	jnc	@f
	xchg	esi, [rep3]
@@:
.1101:
	mov	eax, p + RepLencoder*4
	call	LzmaLenDecode
	push	8
	jmp	.rmu
.10:
	xchg	esi, [rep1]
	xchg	esi, [rep2]
	mov	[rep3], esi
	mov	eax, p + Lencoder*4
	call	LzmaLenDecode
	push	kNumLenToPosStates-1
	pop	eax
	cmp	eax, ecx
	jb	@f
	mov	eax, ecx
@@:
	push	ecx
	push	kNumPosSlotBits
	pop	ecx
	xchg	eax, edx
	mov	eax, p+PosSlot*4
	shl	edx, cl
	call	RangeDecoderBitTreeDecode
	mov	esi, ecx
	cmp	ecx, kStartPosModelIndex
	jb	.l6
	push	ecx
	xor	eax, eax
	inc	eax
	shr	ecx, 1
	adc	al, al
	dec	ecx
	shl	eax, cl
	mov	esi, eax
	pop	edx
	cmp	edx, kEndPosModelIndex
	jae	.l5
	sub	eax, edx
	lea	eax, [p + (SpecPos - 1)*4 + eax*4]
	jmp	.l59
.l5:
	sub	ecx, kNumAlignBits
;	call	RangeDecoderDecodeDirectBits
;RangeDecoderDecodeDirectBits:
	xor	eax, eax
.l:
	shr	dword [range], 1
	add	eax, eax
	mov	edx, [code_]
	sub	edx, [range]
	jb	@f
	mov	[code_], edx
	inc	eax
@@:
	call	update_decoder
	loop	.l
;	ret
	mov	cl, kNumAlignBits
	shl	eax, cl
	add	esi, eax
	mov	eax, p+Align_*4
.l59:
;	call	RangeDecoderReverseBitTreeDecode_addesi
;_RangeDecoderReverseBitTreeDecode_addesi:
; in: eax->probs,ecx=numLevels
; out: esi+=length; destroys edx
	push	edi ecx
	xor	edx, edx
	inc	edx
	xor	edi, edi
@@:
	push	eax
	lea	eax, [eax+edx*4]
	call	RangeDecoderBitDecode
	lahf
	adc	edx, edx
	sahf
	rcr	edi, 1
	pop	eax
	loop	@b
	pop	ecx
	rol	edi, cl
	add	esi, edi
	pop	edi
;	ret
.l6:
	pop	ecx
	not	esi
	push	7
.rmu:
	cmp	ebp, 7
	pop	ebp
	jb	@f
	add	ebp, 3
@@:
.repmovsb:
	inc	ecx
	push	esi
	add	esi, edi
	rep	movsb
	lodsb
	pop	esi
	jmp	.stosb_main_loop
.main_loop_done:
show_addr 'size',$-_RangeDecoderBitDecode
