#include "kosSyst.h"
#include "kosFile.h"
#include "gfxdef.h"
#include "mainWnd.h"
#include "gameWnd.h"
#include "top10wnd.h"




void kos_Main()
{
	int hdrNum, i;
	SCompBmpHeader *hdrList;
	char *cPtr;

	//     
	cPtr = strrchr( kosExePath, '/' );
	//  ;)
	if ( cPtr == NULL )
	{
		//
		rtlDebugOutString( "Invalid path to executable." );
		//
		return;
	}
	//
	cPtr[1] = 0;
	//
	strcpy( top10FilePath, kosExePath );
	//
	strcpy( top10FilePath + ((cPtr - kosExePath) + 1), "fara.t10" );
	//
	PrepareTop10();
	//     
	strcpy( cPtr + 1, "fara.gfx" );
	//    
	CKosFile gfxRes( kosExePath );

	//     
	if ( gfxRes.Read( (Byte *)&hdrNum, sizeof(hdrNum) ) != sizeof(hdrNum) ) return;
	//   
	hdrList = new SCompBmpHeader[hdrNum];
	//   
	gfxRes.Read( (Byte *)hdrList, sizeof(SCompBmpHeader) * hdrNum );
	//  
	mainWndFace.LoadFromArch( &(hdrList[MAIN_FACE_NDX]), &gfxRes, MAIN_FACE_NDX );
	gameFace.LoadFromArch( &(hdrList[GAME_FACE_NDX]), &gfxRes, GAME_FACE_NDX );
	gameBlocks.LoadFromArch( &(hdrList[BUTTONS_NDX]), &gfxRes, BUTTONS_NDX );
	gameNumbers.LoadFromArch( &(hdrList[NUMBERS_NDX]), &gfxRes, NUMBERS_NDX );
	gameBlocksZ[0].LoadFromArch( &(hdrList[BLOCKS32_NDX]), &gfxRes, BLOCKS32_NDX );
	gameBlocksZ[1].LoadFromArch( &(hdrList[BLOCKS24_NDX]), &gfxRes, BLOCKS24_NDX );
	gameBlocksZ[2].LoadFromArch( &(hdrList[BLOCKS16_NDX]), &gfxRes, BLOCKS16_NDX );
	gameBlocksZ[3].LoadFromArch( &(hdrList[BLOCKS8_NDX]), &gfxRes, BLOCKS8_NDX );
	//
	delete hdrList;
	//  
	for ( i = 0; i < blocksNum; i++ )
	{
		//
		fishki[i] = new CFishka( &gameBlocks, i * blockSize, RGB(0x0) );
	}
	//
	maxGameLevel = START_LEVEL;
	//     
	kos_SetMaskForEvents( 0x27 );
	//
	while ( MainWndLoop() == MW_START_GAME )
	{
		GameLoop();
		Top10Loop();
	}
	//
	for ( i = 0; i < blocksNum; i++ )
	{
		delete fishki[i];
	}
	//
	delete hdrList;
}

